# $Header: /usr/custom/cvs/public/EasyPublisher/lib/python/Products/EasyEditor/Storage/DTMLStorage.py,v 1.1 2002/05/30 13:21:22 lennart Exp $
#
# (c) 2002, Torped Strategi och Kommunikation AB.
# See License.txt for License information.
#


__doc__="""Default Storage

$Torped: Storage.py,v 0.0.1 2001/05/14 22:06:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]

import Globals
from Storage import EasyStorageBase
from OFS.DTMLMethod import addDTMLMethod
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base

StringType = type('')

class DTMLStorage(EasyStorageBase):
    """A DTMLStorage Object """

    security = ClassSecurityInfo()

    def _saveDTML(self, name, value, editablecontainer):
        if name not in editablecontainer.objectIds(spec='DTML Method'):
            try:
                addDTMLMethod(editablecontainer, name, name)
            except:
                delattr(editablecontainer, name)
                addDTMLMethod(editablecontainer, name, name)
        obj = editablecontainer._getOb(name)
        obj.manage_edit(value,obj.title)
        setattr(aq_base(editablecontainer),'_' + name + '_storage',self.id)

    security.declarePrivate('manage_save')
    def manage_save(self,name,value,editablecontainer):
        _storage = getattr(aq_base(editablecontainer),'_' + name + '_storage',None)
        if _storage is not None and _storage!=self.id:
            storage = self.getStorage(_storage)
            if storage is not None and hasattr(editablecontainer, name):
                storage.manage_delete(name, editablecontainer)
            elif storage is None: raise "StorageException", "Need to have storage [%s] installed to be able to work with this region." % (_storage,)

        self._saveDTML(name,value,editablecontainer)

    security.declarePrivate('manage_load')
    def manage_load(self,name,editablecontainer,default=None):
        if name in editablecontainer.objectIds(spec='DTML Method'):
            return editablecontainer._getOb(name)
        else:
            return getattr(aq_base(editablecontainer), name, default)

    security.declarePrivate('manage_delete')
    def manage_delete(self, name, editablecontainer):
        editablecontainer._delObject( name)


Globals.InitializeClass(DTMLStorage)




def initialize(context):
    """Initialize Storage Product"""

    context.registerEasyStorage(DTMLStorage,'DTMLStorage')

