# $Header: /usr/custom/cvs/public/EasyPublisher/lib/python/Products/EasyEditor/Storage/PropertyStorage.py,v 1.1 2002/05/30 13:21:22 lennart Exp $
#
# (c) 2002, Torped Strategi och Kommunikation AB.
# See License.txt for License information.
#


__doc__="""PropertyStorage

$Torped: PropertyStorage.py,v 1.4.37 2001/10/12 18:08:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Storage import EasyStorageBase
from ZPublisher.Converters import type_converters
from AccessControl import ClassSecurityInfo
#from Products.EasySecurity import EasyCorePermissions


StringType = type('')
#ListType = type([])
#TupleType = type(())

class PropertyStorage(EasyStorageBase):
    """A PropertyStorage Object """
    property_type = 'None'

    security = ClassSecurityInfo()

    def _saveProperty(self, name, value, editablecontainer):
        setattr(editablecontainer.aq_base,'_' + name + '_storage',self.id)
        if editablecontainer.hasProperty(name):
            if editablecontainer.getPropertyType(name) == self.property_type:
                editablecontainer._updateProperty(name, value)
                return
            else:
                if 'd' in filter(lambda x,name=name: x['id']==name ,editablecontainer._properties)[0]['mode']:
                    editablecontainer._delProperty(name)
                else:
                    raise "Delete Property Error", "You can't delete or convert property [%s], (type: [%s] to new type: [%s])" % (name,editablecontainer.getPropertyType(name) ,self.property_type)
        if type_converters.has_key(self.property_type):
            value=type_converters[self.property_type](value)
        editablecontainer._setProperty(name, value, self.property_type)

    security.declarePrivate('manage_save')
    def manage_save(self,name,value,editablecontainer):
        _storage = getattr(editablecontainer.aq_base,'_' + name + '_storage',None)
        if _storage is not None and _storage!=self.id:
            storage = self.getStorage(_storage)
            if storage is not None:
                storage.manage_delete(name, editablecontainer)
            else: raise "StorageException", "Need to have storage [%s] installed to be able to work with this region." % (_storage,)

        self._saveProperty(name,value,editablecontainer)

    security.declarePrivate('manage_load')
    def manage_load(self,name,editablecontainer,default=None):
        return getattr(editablecontainer.aq_base, name, default)

    security.declarePrivate('manage_delete')
    def manage_delete(self, name, editablecontainer):
        editablecontainer._delProperty(name)


class DatePropertyStorage(PropertyStorage):
    """A DatePropertyStorage Object """
    property_type = 'date'

Globals.InitializeClass(DatePropertyStorage)


class StringPropertyStorage(PropertyStorage):
    """A StringPropertyStorage Object """
    property_type = 'string'

Globals.InitializeClass(StringPropertyStorage)


class TextPropertyStorage(PropertyStorage):
    """A TextPropertyStorage Object """
    property_type = 'text'

Globals.InitializeClass(TextPropertyStorage)


def initialize(context):
    """Initialize PropertyStorage"""

    context.registerEasyStorage(DatePropertyStorage,     'DatePropertyStorage')
    context.registerEasyStorage(StringPropertyStorage,   'StringPropertyStorage')
    context.registerEasyStorage(TextPropertyStorage,     'TextPropertyStorage')
    #context.registerEasyStorage(IntPropertyStorage,     'IntPropertyStorage')
    #context.registerEasyStorage(FloatPropertyStorage,   'FloatPropertyStorage')
    #context.registerEasyStorage(BooleanPropertyStorage, 'BooleanPropertyStorage')
    #context.registerEasyStorage(LinesPropertyStorage,   'LinesPropertyStorage')
    #context.registerEasyStorage(KeywordsPropertyStorage,'KeywordsPropertyStorage')

